//============================================================================//
// This source file is part of work done by Reinder Nijhoff (reinder@infi.nl) //
// For the latest info, see http://developer.infi.nl                          //
//                                                                            //
// You're free to use the code in any way you like, modified, unmodified or   //
// cut'n'pasted into your own work.                                           //
//                                                                            //
// Part of this source is based on work by:                                   //
//    - Humus (http://esprit.campus.luth.se/~humus/)                          //
//    - Paul Baker (http://www.paulsprojects.net)                             //
//============================================================================//

#ifndef  _KERNEL_
#define  _KERNEL_ 1

#include <vector>
#include <string>

#include "includes.hpp"

class Scene;

//==============================================================================
//  Kernel
//==============================================================================
class Kernel {
public:
    Kernel();
    ~Kernel();
    
    void free_data();
    
    void start_renderer();
    void stop_renderer();
 
    void render();
    bool update();
    
    bool read_from_file( const std::string& name );    
private:
    Scene* m_scene;
};

#endif /* KERNEL */

