//============================================================================//
// This source file is part of work done by Reinder Nijhoff (reinder@infi.nl) //
// For the latest info, see http://developer.infi.nl                          //
//                                                                            //
// You're free to use the code in any way you like, modified, unmodified or   //
// cut'n'pasted into your own work.                                           //
//                                                                            //
// Part of this source is based on work by:                                   //
//    - Humus (http://esprit.campus.luth.se/~humus/)                          //
//    - Paul Baker (http://www.paulsprojects.net)                             //
//============================================================================//

#ifndef  _STRING_UTILS_
#define  _STRING_UTILS_ 1

#include <string>

//==============================================================================
//  find_and_replace()
//==============================================================================
void find_and_replace( std::string& source, const std::string& find, const std::string& replace ) {
	size_t j;
	for (;(j = source.find( find )) != std::string::npos;) {
		source.replace( j, find.length(), replace );
	}
}

//==============================================================================
//  trim_right()
//==============================================================================
std::string trim_right ( const std::string & source , const std::string & t = " " ) {
	   std::string str = source;
	   return str.erase ( str.find_last_not_of ( t ) + 1 ) ;
}

//==============================================================================
//  trim_left()
//==============================================================================
std::string trim_left ( const std::string & source , const std::string & t = " " ) {
	   std::string str = source;
	   return str.erase ( 0 , source.find_first_not_of ( t ) ) ;
}

//==============================================================================
//  trim()
//==============================================================================
std::string trim ( const std::string & source , const std::string & t = " " ) {
	  std::string str = source;
	  return trim_left ( trim_right ( str , t ) , t ) ;
}

#endif /* _STRING_UTILS_ */

